100 rem                     Test harness for FSEL
102 :
104 ext_proc 'POKESTR$'
106 ext_fn 'PEEKSTR$', 'RPT%', 'CHAN_W%', 'PICKJOB%'
108 if peek$(\\-4, 4) = 'SBAS': lrespr home_dir$ & 'bin_tool_bin'
110 :
112 rem This demo is for SBASIC + ad hoc toolkit only.
114 :
116 rem                       EXECute to test
118 :
120 wsx% = 200: wsy% = 200
122 cw = fopen("con_")
124 outl#cw; wsx%, wsy%, wsx%, 40, 5, 5
126 paper#cw; 5: border#cw; 2, 5: ink#cw; 0: cls#cw
128 cursor#cw; (wsx% - 24) div 2,  0: print#cw; 'TEST'
130 cursor#cw; (wsx% - 24) div 2, 10: print#cw; '===='
132 ink#cw; 2
134 :
136 addr = ALCHP(44):                       rem Result ends up here
138 POKESTR$ addr, 'win1_prg_':          rem Some default seed
140 :
142 fsel$ = home_dir$ & 'Fsel_obj':         rem App location and name
144 fnm$  = PEEKSTR$(addr)
146 :
148 rem     This runs in a loop until you ESC FSEL or choose the same
150 rem filename twice in succession
152 :
154 rep loop
156  lfn$ = fnm$
158  ert PICKJOB%(#cw; jobid)
160  fnm$ = GetFile$(#cw; fsel$, addr, 2)
162  if fnm$ = '' or fnm$ == lfn$: exit loop
164  print#cw; fnm$
166 endrep loop
168 rechp addr
170 ink#cw; 0
172 cursor#cw; (wsx% - 19 * 6) div 2, wsy% - 14
174 print#cw; 'Press a key to exit': pause#cw
176 quit
178 :
180 def fn GetFile$(ch, fselnm$, fnmaddr, pal)
182 loc x%, y%, fnm$(42), cl$(128)
184 loc hl, id, nj, tv%
186 :
188 fnm$ = PEEKSTR$(fnmaddr)
190 x% = sd_xouto(ch) - (448 - sd_xouts(ch)) / 2
192 y% = sd_youto(ch) + 60
194 cl$ = '/T"Testing FSEL" '
196 cl$ = cl$ & '/X' & x% & ' /Y' & y% & ' /D ' & fnm$ & ' /F ' & fnm$
198 cl$ = cl$ & ' /R $' & HEX$(fnmaddr, 32) & ' /P ' & HEX$(pal, 32)
200 :
202 rem EX job, owned by me (If I die, so does FSEL)
204 id = FEX_M(fselnm$; cl$)
206 if len(job$(id)) = 0: ret '': rem FSEL ERRored; code in addr
208 :
210 tv% = 6: je% = 0: x% = je%: y% = je%: t% = -1
212 rep hl
214  subwin% = RPT%(#ch; tv% ! je%, x%, y%, t%): rem window relative
216  if len(job$(id)) = 0: exit hl: rem Selection done; FSEL terminated
218                                 rem A little finesse here
220  nj = nxjob(id, 0)
222                                 rem If FSEL asleep..
224  if ' asleep' instr job$(nj) then
226   if tv% div 256 then
228    rjob nj, 0: beep 2000,2:     rem If a key pressed, WAKE
230   else
232    next hl:                     rem Otherwise ignore
234   endif
236  endif
238  ert PICKJOB%(#ch; id):         rem Always pick FSEL on top unltil done
240 endrep hl
242 ert PICKJOB%(#ch; jobid):       rem Done! Now me on top!
244 :
246 ret PEEKSTR$(fnmaddr):       rem Return file name (or, rarely, error)
248 END DEFine GetFile
250 :
252 rem               Miscellaneous help routines
254 :
256 rem     Some functions to work out where we are on screen
258 rem         Require the Chan toolkit from Knoware.no
260 def fn sd_xouts(c): ret CHAN_W%(#c; -16): enddef: rem -$10 x outline size
262 def fn sd_xouto(c): ret CHAN_W%(#c; -12): enddef: rem -$0c x outline origin (screen coordinates)
264 def fn sd_youto(c): ret CHAN_W%(#c; -10): enddef: rem -$0a y outline origin (screen coordinates)
266 :
268 :
